Subject: Re: [patch 7/8] lock validator: fix ns83820.c irq-flags bug

From: Jeff Garzik <[email-masked]>
Date: Sun, 11 Jun 2006 12:09:05 -0400

Arjan van de Ven wrote:
> Jeff Garzik wrote:
>> The driver's locking is definitely wrong, but I don't think this is 
>> the fix, 
> 
> it's an obvious correct fix in the correctness sense though...
> 
>>
>> Jesus, the locking here is awful.  No wonder there are bugs.
> 
> 
> ... which given that fact, is for 2.6.17 probably the right thing, pending
> a nicer fix for 2.6.18

I disagree, the patch is wrong too.

For normal PCI hardware, the in-ISR paths should all use spin_lock(), 
and the outside-ISR paths should use either spin_lock_irq() or 
spin_lock_irqsave().

	Jeff